/*
 * file:Utf16ToUtf8_1.c
 */
/** @file
 * @brief UTF-16  UTF-8 ւ̕ϊTvvOB
 * 
 * UTF-16  UTF-8 ւ̕ϊTvvÔPB(Windows APIgp)
 * UTF-16ɂėpӂꂽ"data.txt"t@Cǂݍ݁A
 * UTF-8ւƕϊA
 * "out.txt"t@CւƏo͂܂B
 * ϊ̕BOM΁A܂B
 */
#define STRICT
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#define DEFAULT_BUFF_LEN 512

int Utf16ToUtf8(char *dest, size_t dest_size, wchar_t *src, size_t src_size);

int main(int argc, char *argv[])
{
    wchar_t     instr[DEFAULT_BUFF_LEN];
    char        outstr[DEFAULT_BUFF_LEN];
    FILE        *pFile;
    long        sizeFile = 0;
    size_t      countRead;
    int         instr_size = 0;
    int         iResult = 0;
    char        *pOutStr = NULL;
    
    /*
     * t@C蕶ǂݍ
     */
    memset(instr, 0, sizeof(instr));
    pFile = fopen("data.txt", "rb");
    if (pFile == NULL)
    {
        perror("t@CЂ炯܂: data.txt");
        return 1;
    }
    fseek(pFile, 0, SEEK_END);
    sizeFile = ftell(pFile);
    fseek(pFile, 0, SEEK_SET);
    countRead = fread(instr, min(sizeFile, DEFAULT_BUFF_LEN), 1, pFile);
    fclose(pFile);
    if (countRead == 0)
    {
        perror("t@Cǂݍݎs: data.txt");
        return 1;
    }
    
    instr_size = min(sizeFile, DEFAULT_BUFF_LEN) * countRead / sizeof(wchar_t);
    
    /*
     * utf16:instr -> utf8:outstr ϊB
     */
    memset(outstr, 0, sizeof(outstr));
    iResult = Utf16ToUtf8(outstr, sizeof(outstr), instr, instr_size);
    if (iResult == FALSE)
    {
        perror("Utf16ToUtf8() Failed.\n");
        return 1;
    }
    printf("%d oCgϊ܂B\n", iResult);
    
    pOutStr = outstr;
    /*
     * BOM̏
     */
    if ((*pOutStr == '\xef') && (*(pOutStr + 1) == '\xbb')
            && (*(pOutStr + 2) == '\xbf'))
    {
        /*
         * UTF-8BOMef bb bf
         * LE  BE ݂Ȃ̂ŁABOMt̏ꍇɂ͏B
         * BOMꍇ͂̂܂܏B
         */
        /* BOMꍇɂBOM𖳎 */
        pOutStr += 3;
        iResult -= 3;
    }
    
    /*
     * t@Cɕ݁B
     */
    pFile = fopen("out.txt", "wb");
    if (pFile == NULL)
    {
        perror("t@CJ܂: out.txt");
        return 1;
    }
    fwrite(pOutStr, iResult, 1, pFile);
    fclose(pFile);
    
    return 0;
}

/**
 * R[hUTF-16UTF-8ւƕϊB
 * 
 * @param[out] dest o͕UTF-8
 * @param[in]  dest_size dest̃oCg
 * @param[in]  src ͕UTF-16
 * @param[in]  src_size ͕̕
 * 
 * @return ɂ͏õ͕oCg߂܂B
 *         dest_size 0w肵Å֐ĂяoƁAϊꂽ
 *         i[̂ɕKvdest̃oCg߂܂B
 *         ֐sꍇɂ́AFALSE߂܂B
 */
int Utf16ToUtf8(char *dest, size_t dest_size, wchar_t *src, size_t src_size)
{
    UINT    uCodePage;              /* R[hy[W */
    DWORD   dwFlags;                /* \ƃ}bsÕtO */
    LPCWSTR lpWideCharStr;          /* Ch̃̕AhX */
    int     cchWideChar;            /* ̕ */
    LPSTR   lpMultiByteStr;         /* Ṽobt@̃AhX */
    int     cchMultiByte;           /* obt@̃TCY */
    LPCSTR  lpDefaultChar;          /* }bvs\ȏꍇ̃ftHg̃AhX */
    LPBOOL  lpfUsedDefaultChar;     /* ftHggꂽƂɃZbgtÕAhX */
    int     iResult;
    
    uCodePage           = CP_UTF8;
    dwFlags             = 0;
    lpWideCharStr       = src;
    cchWideChar         = src_size;
    lpMultiByteStr      = dest;
    cchMultiByte        = dest_size;
    lpDefaultChar       = NULL;
    lpfUsedDefaultChar  = NULL;
    iResult = WideCharToMultiByte(uCodePage, dwFlags, lpWideCharStr
            , cchWideChar, lpMultiByteStr, cchMultiByte, lpDefaultChar
            , lpfUsedDefaultChar);
    return iResult;
}
